///Op2FF.h (somewhat less comments file)
//Created by Mcshay
///Last Updated: Friday, July 21st, 2006
///Generic Version

#ifndef OP2FF_H
#define OP2FF_H

#include <windows.h>
#include "Outpost2DLL.h"

#define OFFX 31
#define OFFY -1
#define MAPX 256
#define MAPY 128

///-----------------------------------Notes-------------------------------------
  /*To use the files, download them into the folder where you have your CodeBlocks
    project file. Then open the project and go to Project -> Add files... then select
    one of the Op2FF files and repeat for the other. Now both of the Op2FF files should
    be included in your project when it compiles. Finaly, you need to add the line:
        #include "Op2FF.h"
    near the top of Main.cpp (I would normaly put in below the line #include <OP2Helper.h>).

    Also, all player numbers taken by these functions need to be in the format used by Op2,
    where Player 1 is 0, Player 2 is 1, and so on. All LOCATIONs and MAP_RECTs should have
    the proper map offset already in them:
    example:
        LOCATION(5+31,10-1)
    That will make a location that correctly references the tile 5,10 on a flat map.
    If it didn't have the +31,-1, it would reference the non-existant tile -26,9.

    Make sure you change the 4 macros above this notes section for your map, OFFX should be
    +31 for flat maps, and -1 for world maps. OFFY should be -1 for all maps. MAPX and MAPY
    correspond with your maps width (MAPX) and height (MAPY).*/

///---------------Functions that handel game settings and such------------------

void SetMorale(int MoraleLevel);
void SetDayAndNight(int InitLight);
void SetDisasters();
void RefreshTiles(LOCATION loc);

/*TextStyleKey for EndGame: 
    0 = "MISSION ACCOMPLISHED"
    1 = "MISSION FAILED"
    2 = "GAME OVER"
    3 = "MISSION ABORTED"
    4 = "VICTORY IS SWEET"
    5 = "YOU HAVE BEEN DEFEATED"
    6 = "CONTROL TERMINATED"
    7 = "OUTPOST 2 DEMO" */

/** |Attention|: You must follow the below instructions to use EndGame properly **/
/*DllMain Edit for EndGame:
    Start by deleting the DllMain function entirely from Main.cpp. Then replace it with this:
        extern DWORD *textPtr;
        BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
        {
            if (fdwReason == DLL_PROCESS_ATTACH)
                DisableThreadLibraryCalls(hinstDLL);
            else if (fdwReason == DLL_PROCESS_DETACH)
                *textPtr = 0x004E6160;

            return TRUE;
        }
    This patch to DllMain and the asm in EndGame was made by op2Hacker. */
void EndGame(int Player, int Sound, int TextStyle, char *CustomText);

///---------------------Functions that return information-----------------------

bool IsAtPoint(LOCATION PointToCheck, LOCATION ReferencePoint);
bool IsInRect(LOCATION PointToCheck, MAP_RECT Rect);
map_id GetColonyWeapon(int PlayerNum);
map_id GetColonySpecificPower(int PlayerNum);
LOCATION OffsetLoc(LOCATION Loc, int Xoffset, int Yoffset);

///----------------------Functions that create things---------------------------

/*LineType Key for ChainTubeWall:
    0 = Straight
    1 = Top Left Corner
    2 = Top Right Corner
    3 = Bottom Right Corner
    4 = Bottom Left Corner */

void ChainTubeWall(map_id mapType, int LineType, LOCATION Start, LOCATION End);
void CreatePower(LOCATION PlantLoc, map_id PlantType, int PlayerNum, Unit &x);

///------------------------------Other Functions--------------------------------

void DisplayVariable(char *Part1, int Var, char *Part2, int MaxMessageSize);

///----------------------------------Updates------------------------------------
///Friday, July 21st, 2006:
    //Changes to EndGame made to prevent errors when not using the function
    //Added SetDisasters
///Thursday, July 20th, 2006:
    //File organised and comments typed out
    /*Added SetMorale, SetDayAndNight, RefreshTiles, EndGame, IsAtPoint, &
        IsInRect (developed for the Capture The Flag map) */
    //Updated DisplayVariable
///Lost to Time (aka: older than the 20th):
    //File idea tossed around for a month or so
    //First versions made (few functions)
    //The "add-functions-as-I-do-projects-and-not-just-for-this-file" idea surfaces
///-----------------------------------------------------------------------------

#endif
