///Op2FF.cpp
//Created by Mcshay

#include "Outpost2DLL.h"
#include "Op2FF.h"

void SetMorale(int MoraleLevel)
{
    if(TethysGame::UsesMorale())
        TethysGame::FreeMoraleLevel(-1);
    else
    {
        switch(MoraleLevel)
        {
            case 0:
                TethysGame::ForceMoraleGreat(-1);
                break;
            case 1:
                TethysGame::ForceMoraleGood(-1);
                break;
            case 2:
                TethysGame::ForceMoraleOK(-1);
                break;
            case 3:
                TethysGame::ForceMoralePoor(-1);
                break;
            case 4:
                TethysGame::ForceMoraleRotten(-1);
                break;
            default:
                TethysGame::FreeMoraleLevel(-1);
                break;
        }
    }
}

void SetDayAndNight(int InitLight)
{
        if(TethysGame::UsesDayNight())
        {
            TethysGame::SetDaylightEverywhere(false);
            TethysGame::SetDaylightMoves(true);
            GameMap::SetInitialLightLevel(InitLight);
        }
        else
        {
            TethysGame::SetDaylightEverywhere(true);
            TethysGame::SetDaylightMoves(false);
        }
}

void RefreshTiles(LOCATION loc)
{
    for(int x = loc.x - 1; x <= (loc.x + 1); x++)
    {
        for(int y = loc.y - 1; y <= (loc.y + 1); y++)
        {
            GameMap::SetTile(LOCATION(x,y), GameMap::GetTile(LOCATION(x,y)));
        }
    }
}

bool IsInRect(LOCATION PointToCheck, MAP_RECT Rect)
{
    if((PointToCheck.x >= Rect.x1) && (PointToCheck.x <= Rect.x2) &&
      (PointToCheck.y >= Rect.y1) && (PointToCheck.y <= Rect.y2))
        return true;
    else
        return false;
}

bool IsAtPoint(LOCATION PointToCheck, LOCATION ReferencePoint)
{
    if((PointToCheck.x == ReferencePoint.x) && (PointToCheck.y == ReferencePoint.y))
        return true;
    else
        return false;
}

map_id GetColonyWeapon(int PlayerNum)
{
    if(Player[PlayerNum].IsEden())
        return mapLaser;
    else
        return mapMicrowave;
}

map_id GetColonySpecificPower(int PlayerNum)
{
    if(Player[PlayerNum].IsEden())
        return mapGeothermalPlant;
    else
        return mapMHDGenerator;
}

LOCATION OffsetLoc(LOCATION Loc, int Xoffset, int Yoffset)
{
    Loc.x += Xoffset;
    Loc.y += Yoffset;

    return Loc;
}

void DisplayVariable(char *Part1, int Var, char *Part2, int MaxMessageSize)
{
    char* message = new char[MaxMessageSize];
    scr_snprintf(message, MaxMessageSize, "%s%i%s", Part1, Var, Part2);
    TethysGame::AddMessage(-1, -1, message, -1, 0);
    delete [] message;
}

void ChainTubeWall(map_id mapType, int LineType, LOCATION Start, LOCATION End)
{
    switch(LineType)
    {
      case 0: //Straight
        if(Start.x == End.x) //Vertical Line of Tube
        {
            for(int i = Start.y; i <= End.y; i++)
            {
                TethysGame::CreateWallOrTube(Start.x, i, 0, mapType);
            }
        }
        else // Horizontal Line of Tube
        {
            for(int i = Start.x; i <= End.x; i++)
            {
                TethysGame::CreateWallOrTube(i, Start.y, 0, mapType);
            }
        }
        break;
      case 1: // Top Left Corner Curve
        for(int i = 0; i <= End.x - Start.x; i++)
        {
            TethysGame::CreateWallOrTube(Start.x+i, Start.y, 0, mapType);
        }
        for(int i = 0; i <= End.y - Start.y; i++)
        {
            TethysGame::CreateWallOrTube(Start.x, Start.y+i, 0, mapType);
        }
        break;
      case 2: // Top Right Corner Curve
        for(int i = 0; i <= End.x - Start.x; i++)
        {
            TethysGame::CreateWallOrTube(End.x-i, Start.y, 0, mapType);
        }
        for(int i = 0; i <= End.y - Start.y; i++)
        {
            TethysGame::CreateWallOrTube(End.x, Start.y+i, 0, mapType);
        }
        break;
      case 3: // Bottom Right Corner Curve
        for(int i = 0; i <= End.x - Start.x; i++)
        {
            TethysGame::CreateWallOrTube(End.x-i, End.y, 0, mapType);
        }
        for(int i = 0; i <= End.y - Start.y; i++)
        {
            TethysGame::CreateWallOrTube(End.x, End.y-i, 0, mapType);
        }
        break;
      case 4: // Bottom Left Corner Curve
        for(int i = 0; i <= End.x - Start.x; i++)
        {
            TethysGame::CreateWallOrTube(Start.x+i, End.y, 0, mapType);
        }
        for(int i = 0; i <= End.y - Start.y; i++)
        {
            TethysGame::CreateWallOrTube(Start.x, End.y-i, 0, mapType);
        }
        break;
      default:
        break;
    }
}

void CreatePower(LOCATION PlantLoc, map_id PlantType, int PlayerNum, Unit &x)
{
    if(PlantType == mapGeothermalPlant)
    {
        TethysGame::CreateBeacon(mapFumarole, PlantLoc.x, PlantLoc.y, -1, -1, -1);
        TethysGame::CreateUnit(x, mapGeothermalPlant, LOCATION(PlantLoc.x+1,PlantLoc.y), PlayerNum, mapNone, 0);
    }
    else
    {
        TethysGame::CreateUnit(x, PlantType, PlantLoc, PlayerNum, mapNone, 0);
    }
}

DWORD *textPtr = (DWORD*)0x004E9104;
void EndGame(int Player, int Sound, int TextStyle, char *CustomText)
{
    if(Player != TethysGame::LocalPlayer())
        return;

    char BigText[50];
    switch(TextStyle)
    {
        case 0:
            scr_snprintf(BigText, 50, "MISSION ACCOMPLISHED");
            break;
        case 1:
            scr_snprintf(BigText, 50, "MISSION FAILED");
            break;
        case 2:
            scr_snprintf(BigText, 50, "GAME OVER");
            break;
        case 3:
            scr_snprintf(BigText, 50, "MISSION ABORTED");
            break;
        case 4:
            scr_snprintf(BigText, 50, "VICTORY IS SWEET");
            break;
        case 5:
            scr_snprintf(BigText, 50, "YOU HAVE BEEN DEFEATED");
            break;
        case 6:
            scr_snprintf(BigText, 50, "CONTROL TERMINATED");
            break;
        case 7:
            scr_snprintf(BigText, 50, "OUTPOST 2 DEMO");
            break;
        default:
            scr_snprintf(BigText, 50, CustomText);
            break;
    }

    TethysGame::AddGameSound(Sound, Player);

    *textPtr = (DWORD)&BigText[0];

    int PostGameMsg = 0x48A720;
    __asm
    {
        push 2
        push 7
        mov ecx, 0x56EA98
        call PostGameMsg
    }
}

SCRIPT_API void Storm()
{
    int sX, sY, sD, sEX, sEY;
    sX = TethysGame::GetRand(MAPX) + 1;
    sY = TethysGame::GetRand(MAPY) + 1;
    sD = TethysGame::GetRand(25);
    sEX = TethysGame::GetRand(MAPX) + 1;
    sEY = TethysGame::GetRand(MAPY) + 1;

    TethysGame::SetLightning(sX + OFFX, sY + OFFY, sD, sEX + OFFX, sEY + OFFY);
}

SCRIPT_API void Tornado()
{
    int tX, tY, tD, tEX, tEY;
    tX = TethysGame::GetRand(MAPX) + 1;
    tY = TethysGame::GetRand(MAPY) + 1;
    tD = TethysGame::GetRand(25);
    tEX = TethysGame::GetRand(MAPX) + 1;
    tEY = TethysGame::GetRand(MAPY) + 1;

    TethysGame::SetTornado(tX + OFFX, tY + OFFY, tD, tEX + OFFX, tEY + OFFY, 0);
}

SCRIPT_API void Meteor()
{
    int mX, mY, mS;
    mX = TethysGame::GetRand(MAPX) + 1;
    mY = TethysGame::GetRand(MAPY) + 1;
    mS = TethysGame::GetRand(2);

    TethysGame::SetMeteor(mX + OFFX, mY + OFFY, mS);
}

SCRIPT_API void Quake()
{
    int eX, eY, eM;
    eX = TethysGame::GetRand(MAPX) + 1;
    eY = TethysGame::GetRand(MAPY) + 1;
    eM = TethysGame::GetRand(2);

    TethysGame::SetEarthquake(eX + OFFX, eY + OFFY, eM);
}

void SetDisasters()
{
    if(!TethysGame::CanHaveDisasters())
        return;

    CreateTimeTrigger(true, false,  5000,  10000, "Storm");
    CreateTimeTrigger(true, false, 50000, 100000, "Tornado");
    CreateTimeTrigger(true, false, 10000,  20000, "Meteor");
    CreateTimeTrigger(true, false,  5000,  10000, "Quake");
}
